"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _configuration = require("../configuration");

// Common validator for single target effects
// Effects using this validator should be wrapped into an object with the shape:
// {
//   realTarget: the target being modified. Notice that it may be different of action.target,
//   do: the effect itself
// }
function validateEffect(effect) {
  return function (state, action) {
    if (!action.target) {
      console.warn("There is no target specified for ".concat(effect.name, "."));
    }

    if (state[effect.realTarget(action)] === undefined) {// TODO: RESTORE THIS WARNING
      // console.warn(`Missing field declaration for ${effect.realTarget(action)}.`);
    }

    return (0, _configuration.mergeState)(state, (0, _defineProperty2["default"])({}, effect.realTarget(action), effect["do"](action, state)));
  };
}

var _default = validateEffect;
exports["default"] = _default;